/* #############################################################################################
   ###########################   TEXT BILD CONTAINER 2  WIDGET ZP    ###########################
   ############################################################################################# */
(function ($) {
    $.fn.wzpTextBildZ = function () {
        $(this).each(function () {
            var container = $(this),
                textcontainer = container.children('.wzp-tbcz_text'),
                text = textcontainer.children('div'),
                picturecontainer = container.children('.wzp-tbcz_picture'),
                picture = picturecontainer.find('img'),
                heightmode = container.attr('data-heightmode'),
                parallax = parseInt(container.attr('data-parallax')),
                maxOffset = 0,
                fade = true,
                pictureRatio = parseFloat(picture.attr('width')) / parseFloat(picture.attr('height'));

            function placePicture() {
                if (picture.css('position') === 'absolute') {
                    var pictureHeight = Math.floor(picturecontainer.width() / pictureRatio),
                        height = Math.floor(pictureHeight * (1 - parallax / 100)),
                        textHeight = Math.ceil(text.outerHeight());

                    if (height < textHeight) {
                        height = textHeight;
                        pictureHeight = Math.floor(height * (1 + parallax / 100));
                    }

                    if (heightmode === 'window' && height < $(window).height()) {
                        height = $(window).height();
                        pictureHeight = Math.floor(height * (1 + parallax / 100));
                    }


                    picturecontainer.css({
                        'height': height + 'px'
                    });
                    textcontainer.css({
                        'height': height + 'px'
                    });

                    var pictureWidth = Math.ceil(pictureHeight * pictureRatio);

                    if (pictureWidth < picturecontainer.width()) {
                        pictureWidth = picturecontainer.width();
                        pictureHeight = Math.ceil(pictureWidth / pictureRatio);
                    }

                    var pictureLeft = Math.floor((picturecontainer.width() - pictureWidth) / 2);

                    picture.css({
                        'height': pictureHeight + 'px',
                        'width': pictureWidth + 'px',
                        'left': pictureLeft + 'px'
                    });

                    maxOffset = pictureHeight - height;
                } else {
                    picturecontainer.css({
                        'height': 'inherit'
                    });
                    textcontainer.css({
                        'height': 'inherit'
                    });
                    picture.css({
                        'height': 'auto',
                        'width': '100%'
                    });
                    maxOffset = 0;
                }
            }

            function setPictureOffset() {

                var containerTop = picturecontainer.offset().top,
                    containerHeight = picturecontainer.height(),
                    windowheight = $(window).height(),
                    scrolltop = $(window).scrollTop();

                if (parallax > 0) {
                    var top = scrolltop + windowheight - containerTop,
                        range = windowheight + containerHeight,
                        offset = -Math.floor((1 - (top / range)) * maxOffset);
                    picture.css('transform', 'translateY(' + offset + 'px)');
                }

                if (fade) {
                    if (containerTop + containerHeight / 3 < scrolltop + windowheight) {
                        container.addClass('wzp-tbcz_show');
                        fade = false;
                    }
                }
            }

            placePicture();
            placePicture();

            $(window).on('resize load', function () {
                placePicture();
                placePicture();
                setPictureOffset();
            });

            $(window).on('scroll', setPictureOffset);
        });
    };
})(jQuery);

$(document).ready(function () {
    $('.wzp-tbcz').wzpTextBildZ();
});  
/* #############################################################################################
   #####################   ENDE JS TEXT BILD CONTAINER 2  WIDGET ZP    #########################
   ############################################################################################# */